<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Eddie: /builds/eclipse/oniro-core/eddie/common/include/EddieEndpoint.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Eddie
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_bdd9a5d540de89e9fe90efdfc6973a4f.html">common</a></li><li class="navelem"><a class="el" href="dir_11fbc4217d50ab21044e5ad6614aede5.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">EddieEndpoint.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2022 Huawei Inc.</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * SPDX-License-Identifier: Apache-2.0</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160; </div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#ifndef __EDDIEENDPOINT_H__</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#define __EDDIEENDPOINT_H__</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;CoapClient.h&quot;</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;CoapServer.h&quot;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;eddie.h&quot;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="classEddieEndpoint.html">   16</a></span>&#160;<span class="keyword">class </span><a class="code" href="classEddieEndpoint.html">EddieEndpoint</a> {</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    <a class="code" href="classCoapServer.html">CoapServer</a> *server = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    std::string resource_directory_ip;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    std::string resource_directory_port;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    std::string ep;                 <span class="comment">// endpoint name</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    std::string d;                  <span class="comment">// sector name</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    std::string rd_endpoint;        <span class="comment">// rd endpoint string</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="classEddieEndpoint.html#af4a195aaa66df7a9f80a1a779dd7124b">   35</a></span>&#160;    <span class="keyword">explicit</span> <a class="code" href="classEddieEndpoint.html#af4a195aaa66df7a9f80a1a779dd7124b">EddieEndpoint</a>(<span class="keyword">const</span> std::string&amp; port = <span class="stringliteral">&quot;5683&quot;</span>, <span class="keyword">const</span> std::string&amp; ip = <span class="stringliteral">&quot;&quot;</span>);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    ~<a class="code" href="classEddieEndpoint.html">EddieEndpoint</a>();</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160; </div>
<div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="classEddieEndpoint.html#aaaa263a103754ccbc37201f76fa1500f">   42</a></span>&#160;    <a class="code" href="classCoapClient.html">CoapClient</a>* <a class="code" href="classEddieEndpoint.html#aaaa263a103754ccbc37201f76fa1500f">get_client</a>();</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div>
<div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="classEddieEndpoint.html#aeaeb77ed5c8f985027b986002fa849d4">   47</a></span>&#160;    <a class="code" href="classCoapServer.html">CoapServer</a>* <a class="code" href="classEddieEndpoint.html#aeaeb77ed5c8f985027b986002fa849d4">get_server</a>();</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div>
<div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="classEddieEndpoint.html#a6e5cdae0155792d7fb24d7946e733647">   53</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classEddieEndpoint.html#a6e5cdae0155792d7fb24d7946e733647">discover_rd</a>();</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160; </div>
<div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="classEddieEndpoint.html#adb40a77a9c022410d343b655b687783e">   59</a></span>&#160;    std::vector&lt;Link&gt; <a class="code" href="classEddieEndpoint.html#adb40a77a9c022410d343b655b687783e">get_resources_from_rd</a>();</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div>
<div class="line"><a name="l00066"></a><span class="lineno"><a class="line" href="classEddieEndpoint.html#a74069f4ca61eb820845e04e8e79fac86">   66</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classEddieEndpoint.html#a74069f4ca61eb820845e04e8e79fac86">add_resource</a>(<a class="code" href="classEddieResource.html">EddieResource</a> *resource);</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div>
<div class="line"><a name="l00073"></a><span class="lineno"><a class="line" href="classEddieEndpoint.html#a46183ccdfd5ac6799be0cf67c0c2ffc0">   73</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classEddieEndpoint.html#a46183ccdfd5ac6799be0cf67c0c2ffc0">start_server</a>(<span class="keywordtype">bool</span> blocking = <span class="keyword">false</span>);</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160; </div>
<div class="line"><a name="l00079"></a><span class="lineno"><a class="line" href="classEddieEndpoint.html#a98c8ab9733c42b91da5d57ca3b90f046">   79</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classEddieEndpoint.html#a98c8ab9733c42b91da5d57ca3b90f046">stop_server</a>();</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160; </div>
<div class="line"><a name="l00085"></a><span class="lineno"><a class="line" href="classEddieEndpoint.html#ac2b7796e7b0f4d71b1eacc622ff95e2f">   85</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classEddieEndpoint.html#ac2b7796e7b0f4d71b1eacc622ff95e2f">publish_resources</a>();</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160; </div>
<div class="line"><a name="l00091"></a><span class="lineno"><a class="line" href="classEddieEndpoint.html#a5f2facfeaa261ae316996d492efe0a3b">   91</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classEddieEndpoint.html#a5f2facfeaa261ae316996d492efe0a3b">unpublish_resources</a>();</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160; </div>
<div class="line"><a name="l00096"></a><span class="lineno"><a class="line" href="classEddieEndpoint.html#a297457642ef038b839a451a90b481476">   96</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classEddieEndpoint.html#a297457642ef038b839a451a90b481476">init_resource_dir_local</a>();</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;};</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160; </div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="ttc" id="aclassCoapClient_html"><div class="ttname"><a href="classCoapClient.html">CoapClient</a></div><div class="ttdef"><b>Definition:</b> CoapClient.h:24</div></div>
<div class="ttc" id="aclassCoapServer_html"><div class="ttname"><a href="classCoapServer.html">CoapServer</a></div><div class="ttdef"><b>Definition:</b> CoapServer.h:26</div></div>
<div class="ttc" id="aclassEddieEndpoint_html"><div class="ttname"><a href="classEddieEndpoint.html">EddieEndpoint</a></div><div class="ttdef"><b>Definition:</b> EddieEndpoint.h:16</div></div>
<div class="ttc" id="aclassEddieEndpoint_html_a297457642ef038b839a451a90b481476"><div class="ttname"><a href="classEddieEndpoint.html#a297457642ef038b839a451a90b481476">EddieEndpoint::init_resource_dir_local</a></div><div class="ttdeci">void init_resource_dir_local()</div></div>
<div class="ttc" id="aclassEddieEndpoint_html_a46183ccdfd5ac6799be0cf67c0c2ffc0"><div class="ttname"><a href="classEddieEndpoint.html#a46183ccdfd5ac6799be0cf67c0c2ffc0">EddieEndpoint::start_server</a></div><div class="ttdeci">int start_server(bool blocking=false)</div></div>
<div class="ttc" id="aclassEddieEndpoint_html_a5f2facfeaa261ae316996d492efe0a3b"><div class="ttname"><a href="classEddieEndpoint.html#a5f2facfeaa261ae316996d492efe0a3b">EddieEndpoint::unpublish_resources</a></div><div class="ttdeci">int unpublish_resources()</div></div>
<div class="ttc" id="aclassEddieEndpoint_html_a6e5cdae0155792d7fb24d7946e733647"><div class="ttname"><a href="classEddieEndpoint.html#a6e5cdae0155792d7fb24d7946e733647">EddieEndpoint::discover_rd</a></div><div class="ttdeci">int discover_rd()</div></div>
<div class="ttc" id="aclassEddieEndpoint_html_a74069f4ca61eb820845e04e8e79fac86"><div class="ttname"><a href="classEddieEndpoint.html#a74069f4ca61eb820845e04e8e79fac86">EddieEndpoint::add_resource</a></div><div class="ttdeci">int add_resource(EddieResource *resource)</div></div>
<div class="ttc" id="aclassEddieEndpoint_html_a98c8ab9733c42b91da5d57ca3b90f046"><div class="ttname"><a href="classEddieEndpoint.html#a98c8ab9733c42b91da5d57ca3b90f046">EddieEndpoint::stop_server</a></div><div class="ttdeci">int stop_server()</div></div>
<div class="ttc" id="aclassEddieEndpoint_html_aaaa263a103754ccbc37201f76fa1500f"><div class="ttname"><a href="classEddieEndpoint.html#aaaa263a103754ccbc37201f76fa1500f">EddieEndpoint::get_client</a></div><div class="ttdeci">CoapClient * get_client()</div></div>
<div class="ttc" id="aclassEddieEndpoint_html_ac2b7796e7b0f4d71b1eacc622ff95e2f"><div class="ttname"><a href="classEddieEndpoint.html#ac2b7796e7b0f4d71b1eacc622ff95e2f">EddieEndpoint::publish_resources</a></div><div class="ttdeci">int publish_resources()</div></div>
<div class="ttc" id="aclassEddieEndpoint_html_adb40a77a9c022410d343b655b687783e"><div class="ttname"><a href="classEddieEndpoint.html#adb40a77a9c022410d343b655b687783e">EddieEndpoint::get_resources_from_rd</a></div><div class="ttdeci">std::vector&lt; Link &gt; get_resources_from_rd()</div></div>
<div class="ttc" id="aclassEddieEndpoint_html_aeaeb77ed5c8f985027b986002fa849d4"><div class="ttname"><a href="classEddieEndpoint.html#aeaeb77ed5c8f985027b986002fa849d4">EddieEndpoint::get_server</a></div><div class="ttdeci">CoapServer * get_server()</div></div>
<div class="ttc" id="aclassEddieEndpoint_html_af4a195aaa66df7a9f80a1a779dd7124b"><div class="ttname"><a href="classEddieEndpoint.html#af4a195aaa66df7a9f80a1a779dd7124b">EddieEndpoint::EddieEndpoint</a></div><div class="ttdeci">EddieEndpoint(const std::string &amp;port=&quot;5683&quot;, const std::string &amp;ip=&quot;&quot;)</div></div>
<div class="ttc" id="aclassEddieResource_html"><div class="ttname"><a href="classEddieResource.html">EddieResource</a></div><div class="ttdef"><b>Definition:</b> eddie.h:82</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
